/* ***** BEGIN LICENSE BLOCK *****
 * Licensed under Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * Full Terms at http://mozile.mozdev.org/license.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Playsophy code.
 *
 * The Initial Developer of the Original Code is Playsophy
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * James A. Overton <james@overton.ca>
 * Andreas Schamberger <mozile@andreass.net>
 * Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

var mozileBug;	//Reference to the debug object passed to this window.

function init(event)
{
	if (event.target == document)
	{
		if ( "arguments" in window ) {
			var n = window.arguments.length;
			if (n==1)
			{
				mozileBug = window.arguments[0];
				reset();
			}
		}
	}
}

function reset() 
{
	document.getElementById('filterText').value = "";
	document.getElementById('filterLevel').selectedIndex=3;
	refresh();
}

function refresh()
{
	filter();
}

function clear()
{
	mozileBug.reset();
	reset();
}


function filter()
{
	//Get the selected Filter Level
	var selected = document.getElementById('filterLevel').value;
	//Get the filter text
	var text = document.getElementById('filterText').value;
	//Clear all the old messages
	var vbox = document.getElementById("bugs");
	vbox = removeChildren(vbox);

	for(var i=0; i < mozileBug.data.length; i++)
	{
		var bug = mozileBug.data[i];

		if(selected <= bug[2]) {
	  //Don't display bugs if less important than the selected level.
			continue;
		}

		if ( text ) {
		// If filter text, search filename, function and message...
			if ( (bug[1][0].search(text)==-1) && (bug[1][1].search(text)==-1) && (bug[3].search(text)==-1) ) {
		 		continue; //Skip if filter text not found.
			}
		}
		var hbox = makeBug(bug);
		vbox.insertBefore(hbox,vbox.firstChild);
	}

	function removeChildren(node)
	{
		var clone = node.cloneNode(false);
		var parent = node.parentNode;
		parent.replaceChild(clone,node);
		return clone;
	}
}


function makeBug(bug)
{
	var hbox = document.createElement("hbox");
	hbox.setAttribute("class", "level"+bug[2]);
		
	var datestamp = document.createElement("description");
	datestamp.setAttribute("class","datestamp");
	datestamp.setAttribute("value",bug[0]);
	hbox.appendChild(datestamp);
		
	var functions = document.createElement("description");
	functions.setAttribute("class","functions");
	functions.setAttribute("value", "["+ bug[1] +"]");
	hbox.appendChild(functions);
		
	var message = document.createElement("description");
	message.setAttribute("class","message");
	message.flex="1";
	var messageText = document.createTextNode(bug[3]);
	message.appendChild(messageText);
	hbox.appendChild(message);

	return hbox;
}


